import { compose } from 'redux';
import { ensureAsync } from './helpers/promises';

var chain = function chain(thunks) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return function (dispatch) {
      var first = thunks[0];
      var initial = ensureAsync(compose(dispatch, first));

      return thunks.slice(1).reduce(function (promise, thunk) {
        return promise.then(compose(dispatch, thunk));
      }, initial.apply(undefined, args));
    };
  };
};

export default chain;