import { ensureAsyncCompose } from './helpers/promises';
import StateManager from './helpers/state-manager';
import { ensureFunc } from './helpers/funcs';

var lazy0 = function lazy0() {
  return 0;
};

var chained = function chained(keySelector) {
  return function (thunk) {
    var _StateManager = StateManager(),
        assign = _StateManager.assign,
        get = _StateManager.get;

    var getKey = ensureFunc(keySelector, lazy0);

    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return function (dispatch) {
        var key = getKey.apply(undefined, args);
        var promise = get(key);
        var newThunk = ensureAsyncCompose(dispatch, thunk);

        return assign(key, promise ? promise.then(function () {
          return newThunk.apply(undefined, args);
        }) : newThunk.apply(undefined, args));
      };
    };
  };
};

export default chained;