import { bindActionCreators } from 'redux';
import { bindSelectors } from './helpers/bind-selectors';
import idX from './helpers/idX';

var createThunk = function createThunk() {
  var actionCreators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : idX;
  var selectors = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : idX;
  return function (func) {
    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return function (dispatch, getState) {
        return func.apply(undefined, [bindActionCreators(actionCreators, dispatch), bindSelectors(selectors, getState)].concat(args));
      };
    };
  };
};

export default createThunk;