import { compose } from 'redux';

export var isPromise = function isPromise(value) {
  return value != null && typeof value.then === 'function';
};

export var ensureResolved = function ensureResolved(value) {
  return isPromise(value) ? value : Promise.resolve(value);
};

export var ensureRejected = function ensureRejected(value) {
  return isPromise(value) ? value : Promise.reject(value);
};

export var ensureAsync = function ensureAsync(fn) {
  return function () {
    try {
      return ensureResolved(fn.apply(undefined, arguments));
    } catch (err) {
      return ensureRejected(err);
    }
  };
};

export var ensureAsyncCompose = compose(ensureAsync, compose);