var assign = function assign(branches) {
  return function (key, branch) {
    branches[key] = branch;
    return branch;
  };
};

var reset = function reset(branches) {
  return function (key) {
    return function () {
      branches[key] = null;
    };
  };
};

var get = function get(branches) {
  return function (id) {
    return branches[id];
  };
};

var IStateManager = function IStateManager(branches) {
  return {
    assign: assign(branches),
    reset: reset(branches),
    get: get(branches)
  };
};

var StateManager = function StateManager() {
  return IStateManager([]);
};

export default StateManager;