import { ensureAsyncCompose } from './helpers/promises';
import { ensureFunc } from './helpers/funcs';
import StateManager from './helpers/state-manager';
import TimerState from './helpers/timer-state';

var lazy0 = function lazy0() {
  return 0;
};

var postponded = function postponded(delay, keySelector) {
  return function (thunk) {
    var _StateManager = StateManager(),
        assign = _StateManager.assign,
        get = _StateManager.get;

    var getKey = ensureFunc(keySelector, lazy0);

    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return function (dispatch) {
        var key = getKey.apply(undefined, args);
        var timer = get(key) || TimerState(delay);
        var newThunk = ensureAsyncCompose(dispatch, thunk);

        assign(key, timer.startWith(function () {
          return newThunk.apply(undefined, args);
        }));

        return timer.promise;
      };
    };
  };
};

export default postponded;