import { ensureAsyncCompose } from './helpers/promises';
import StateManager from './helpers/state-manager';
import { ensureFunc } from './helpers/funcs';

var lazy0 = function lazy0() {
  return 0;
};

var single = function single(keySelector) {
  return function (thunk) {
    var _StateManager = StateManager(),
        assign = _StateManager.assign,
        reset = _StateManager.reset,
        get = _StateManager.get;

    var getKey = ensureFunc(keySelector, lazy0);

    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return function (dispatch) {
        var key = getKey.apply(undefined, args);
        var promise = get(key);

        if (promise) return promise;

        var newThunk = ensureAsyncCompose(dispatch, thunk);
        return assign(key, newThunk.apply(undefined, args).finally(reset(key)));
      };
    };
  };
};

export default single;