'use strict';

exports.__esModule = true;

var _redux = require('redux');

var _promises = require('./helpers/promises');

var chain = function chain(thunks) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return function (dispatch) {
      var first = thunks[0];
      var initial = (0, _promises.ensureAsync)((0, _redux.compose)(dispatch, first));

      return thunks.slice(1).reduce(function (promise, thunk) {
        return promise.then((0, _redux.compose)(dispatch, thunk));
      }, initial.apply(undefined, args));
    };
  };
};

exports.default = chain;