'use strict';

exports.__esModule = true;

var _redux = require('redux');

var _bindSelectors = require('./helpers/bind-selectors');

var _idX = require('./helpers/idX');

var _idX2 = _interopRequireDefault(_idX);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createThunk = function createThunk() {
  var actionCreators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _idX2.default;
  var selectors = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _idX2.default;
  return function (func) {
    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return function (dispatch, getState) {
        return func.apply(undefined, [(0, _redux.bindActionCreators)(actionCreators, dispatch), (0, _bindSelectors.bindSelectors)(selectors, getState)].concat(args));
      };
    };
  };
};

exports.default = createThunk;