'use strict';

exports.__esModule = true;
exports.withHandler = undefined;

var _redux = require('redux');

var _promises = require('./promises');

var withHandler = exports.withHandler = function withHandler(promiseMethod) {
  return function (handlingThunk) {
    for (var _len = arguments.length, handlingArgs = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      handlingArgs[_key - 1] = arguments[_key];
    }

    return function (thunk) {
      return function () {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return function (dispatch) {
          var asyncThunk = (0, _promises.ensureAsyncCompose)(dispatch, thunk);
          var handler = (0, _redux.compose)(dispatch, function () {
            for (var _len3 = arguments.length, newArgs = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
              newArgs[_key3] = arguments[_key3];
            }

            return handlingThunk.apply(undefined, handlingArgs.concat(newArgs));
          });

          var promise = asyncThunk.apply(undefined, args);
          return promise[promiseMethod](handler);
        };
      };
    };
  };
};