'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var bindSelector = function bindSelector(getState) {
  return function (selector) {
    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return selector.apply(undefined, [getState()].concat(args));
    };
  };
};

var _bindSelectors = function _bindSelectors(selectors, getState) {
  var bind = bindSelector(getState);
  return Object.keys(selectors).reduce(function (bound, name) {
    bound[name] = bind(selectors[name]);
    return bound;
  }, {});
};

var bindSelectors = exports.bindSelectors = function bindSelectors(selectors, getState) {
  return Array.isArray(selectors) ? selectors.map(bindSelector(getState)) : typeof selectors === 'function' ? selectors(getState) : (typeof selectors === 'undefined' ? 'undefined' : _typeof(selectors)) === 'object' ? _bindSelectors(selectors, getState) : getState;
};