'use strict';

exports.__esModule = true;
exports.ensureAsyncCompose = exports.ensureAsync = exports.ensureRejected = exports.ensureResolved = exports.isPromise = undefined;

var _redux = require('redux');

var isPromise = exports.isPromise = function isPromise(value) {
  return value != null && typeof value.then === 'function';
};

var ensureResolved = exports.ensureResolved = function ensureResolved(value) {
  return isPromise(value) ? value : Promise.resolve(value);
};

var ensureRejected = exports.ensureRejected = function ensureRejected(value) {
  return isPromise(value) ? value : Promise.reject(value);
};

var ensureAsync = exports.ensureAsync = function ensureAsync(fn) {
  return function () {
    try {
      return ensureResolved(fn.apply(undefined, arguments));
    } catch (err) {
      return ensureRejected(err);
    }
  };
};

var ensureAsyncCompose = exports.ensureAsyncCompose = (0, _redux.compose)(ensureAsync, _redux.compose);