"use strict";

exports.__esModule = true;
var TimerState = function TimerState(delay) {
  var timer = null;
  var resolve = null;
  var reject = null;
  var self = null;

  var startWith = function startWith(cb) {
    if (timer) clearTimeout(timer);

    timer = setTimeout(function () {
      return cb().then(resolve, reject);
    }, delay);

    return self;
  };

  var assignResolveReject = function assignResolveReject(_resolve, _reject) {
    resolve = _resolve;
    reject = _reject;
  };

  self = {
    promise: new Promise(assignResolveReject),
    startWith: startWith
  };

  return self;
};

exports.default = TimerState;