'use strict';

exports.__esModule = true;

var _promises = require('./helpers/promises');

var loading = function loading(start, end) {
  return function () {
    for (var _len = arguments.length, loadingArgs = Array(_len), _key = 0; _key < _len; _key++) {
      loadingArgs[_key] = arguments[_key];
    }

    return function (thunk) {
      return function () {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return function (dispatch) {
          if (typeof start === 'function') {
            dispatch(start.apply(undefined, loadingArgs));
          }

          var asyncThunk = (0, _promises.ensureAsyncCompose)(dispatch, thunk);

          var promise = asyncThunk.apply(undefined, args);

          if (typeof end === 'function') {
            promise.finally(function () {
              return dispatch(end.apply(undefined, loadingArgs));
            });
          }

          return promise;
        };
      };
    };
  };
};

exports.default = loading;