'use strict';

exports.__esModule = true;

var _promises = require('./helpers/promises');

var _funcs = require('./helpers/funcs');

var _stateManager = require('./helpers/state-manager');

var _stateManager2 = _interopRequireDefault(_stateManager);

var _timerState = require('./helpers/timer-state');

var _timerState2 = _interopRequireDefault(_timerState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var lazy0 = function lazy0() {
  return 0;
};

var postponded = function postponded(delay, keySelector) {
  return function (thunk) {
    var _StateManager = (0, _stateManager2.default)(),
        assign = _StateManager.assign,
        get = _StateManager.get;

    var getKey = (0, _funcs.ensureFunc)(keySelector, lazy0);

    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return function (dispatch) {
        var key = getKey.apply(undefined, args);
        var timer = get(key) || (0, _timerState2.default)(delay);
        var newThunk = (0, _promises.ensureAsyncCompose)(dispatch, thunk);

        assign(key, timer.startWith(function () {
          return newThunk.apply(undefined, args);
        }));

        return timer.promise;
      };
    };
  };
};

exports.default = postponded;